/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <qstringlist.h>
#include<qstatusbar.h>
#include <qprocess.h>
#include <qstring.h>
#include <qfile.h>
#include <qstringlist.h>
#include <iostream>
#include "mplayer.h"

QStringList Channels;
MPlayer MP;

void MainForm::init()
{
    QStringList lines;
    QFile file( "/usr/local/lib/dune/channels.txt" );
    if ( file.open( IO_ReadOnly ) ) 
    {
	QTextStream stream( &file );
	QString line, cname, channel;
	int i = 0;
	while ( !stream.atEnd() ) 
	{
	    line = stream.readLine(); 
	    std::cout << line.latin1() << std::endl;
	    if(!line.isEmpty())
	    {
		cbProgram->insertItem(line.section("  ", 1, 1));
		Channels.append( line.section("  ", 0, 0) );
	    }
	    lines += line;
	    i++;
	}
	file.close();
    }
    
    cbQuality->insertItem("dvd");
    cbQuality->insertItem("dvdlong");
    cbQuality->insertItem("dvd5mbit");
    cbQuality->insertItem("svcd");
    cbQuality->insertItem("vcd");    
    cbQuality->insertItem("svcd2");    
    cbQuality->insertItem("vcd2"); 
    
    cbInput->insertItem("Antenna");
    cbInput->insertItem("SVideo");
    cbInput->insertItem("Composite");
    
    cbDeinterlace->insertItem("none");
    cbDeinterlace->insertItem("scale");
    cbDeinterlace->insertItem("lib-avc");
    cbDeinterlace->insertItem("median");
    cbDeinterlace->insertItem("linear");
    cbDeinterlace->insertItem("cubic");
    cbDeinterlace->insertItem("linearblend");
    cbDeinterlace->insertItem("ffmpeg");
}

void MainForm::helpAbout()
{

}


void MainForm::addAO( char *line )
{
    QStringList *sl = new QStringList();
    *sl = sl->split(QString(" "),QString(line));
    for(int i=0;i<sl->size()-1;i++)
    {
	cbAudio->insertItem((*sl)[i]);
    }
}


void MainForm::addVO( char *line )
{
    QStringList *sl = new QStringList();
    *sl = sl->split(QString(" "),QString(line));
    for(int i=0;i<sl->size()-1;i++)
    {
	cbVideo->insertItem((*sl)[i]);
    }
}



void MainForm::inputChanged( int Item )
{
    if(Item==0)
	cbProgram->setEnabled(true);
    else
	cbProgram->setEnabled(false);
}


void MainForm::play()
{
    QString line;
    statusBar()->message("Playing " + cbProgram->currentText());
    line.append("dunerec -i ");
    switch(cbInput->currentItem())
    {
    case 0:
	line.append("0 -a ");
	line.append(Channels[cbProgram->currentItem()]);
	break;
    case 1:
	line.append("1 ");
	break;
    case 2:		
	line.append("2 ");
	break;
    }
    line.append(" -t ");
    line.append(cbQuality->currentText());
    line.append(" -R - | mplayer -vo ");
    line.append(cbVideo->currentText());
    line.append(" -ao ");
    line.append(cbAudio->currentText());
    line.append(" -double -cache 4096 ");
    
    if(cBFrameDrop->isChecked())
	line.append("-framedrop ");
    line.append("-");
    MP.line = line;
    MP.start();
    //system(line.ascii());
    //statusBar()->message("Stopped playing");
}




